#GRL Estimation

rm(list=ls(all=TRUE))
setwd("D:/夏の学校2019/経路選択RL")

input_area <- "D:/夏の学校2019/経路選択RL/input"
inputDataPass <- paste(input_area, "route_return.csv", sep = "/") # route_***.csv
inputLinkPass <- paste(input_area, "network/link_with_dummy.csv", sep = "/")
inputMatrixPass <- paste(input_area, "network/matrix_added.csv", sep = "/")
inputDistancePass <- paste(input_area, "network/distance2parking.csv", sep = "/")

readdata.number <- -1 # -1 = all

############### time measure ############
message("PROGRAM START!\n")
t<-proc.time()


#########################################
########  reading & sampling    #########
#########################################


########## result data reading ##########
data <- read.csv(inputDataPass, nrows = readdata.number)
names(data) <- c("k","a","d")
ddata <- sort(unique(data$d))
kdata <- list()
dataList <- list()

for(i in 1:length(ddata)){
  sub <- subset(data,data$d == ddata[i])
  kdata[[i]] <- sort(unique(sub$k)) 
  dataList[[i]] <- sub
  #print(dataList)
}

########## link data reading ############
link <- read.csv(inputLinkPass, as.is=T)
linkid <- sort(unique(link$LinkID))

########## link matrix reading ##########
matrix <- read.csv(inputMatrixPass)
matrix <- matrix[, c(1,2)]
names(matrix) <- c("k", "a")
asetdataList <- list()
matrixList <- list()

for(j in 1:length(ddata)){
  asetdata <- c()
  submatrix <- data.frame("k"=c(-1), "a"=c(-1))
  #print(submatrix)
  
  for(i in 1:length(kdata[[j]])){
    sub <- subset(matrix, matrix$k == kdata[[j]][i])
    submatrix <- rbind(submatrix, sub)
    asetdata <- c(asetdata, sub$a)
  }
  
  asetdataList[[j]] <- sort(unique(asetdata))
  matrixList[[j]] <- subset(submatrix, submatrix$k > 0)
}

################# index #################
#dlength <- length(ddata)
#llength <- length(link$LinkID)
D <- length(unique(data$d))
L <- length(linkid)

AList <- list()
for(k in 1:L){
  kl <- linkid[k]
  sub <- subset(matrix, matrix$k == kl)
  AList[[k]] <- sub$a
}

############# value function ############
V0 <- array(-1, dim = c(L, D))
z0 <- exp(V0)

############# return dummy ##############
#Return <- subset(matrix, link$return == 1)
#names(Return) <- c("k", "a", "return")
#RR <- array(exp(0), dim = c(L, L))

#for(s in 1:nrow(Return)){
#  kl <- Return$k[s]
#  al <- Return$a[s]
#  k <- (1:L)[linkid == kl]
#  a <- (1:L)[linkid == al]
#  RR[k,a] <- exp(1)
#}

######### link connectiuon dummy ########
I <- array(0, dim = c(L, L))

for(i in 1:nrow(matrix)){
  kl <- matrix$k[i]
  al <- matrix$a[i]
  k <- (1:L)[linkid == kl]
  a <- (1:L)[linkid == al]
  I[k,a] <- 1
}

Ilist <- list()

for(d in 1:D){
  dl <- ddata[d]
  dn <- (1:L)[linkid == dl]
  Id <- I
  Id[dn, ] <- 0
  
  for(k in 1:L){
    aList <- AList[[k]]
    if(is.element(dl, aList)){
      Id[k, ] <- 0
      Id[k, dn] <- 1
    }
  }
  
  Ilist[[d]] <- Id
  V0[dn, d] <- 0
  z0[dn, d] <- 1
}

############ parameter init #############
binit <- numeric(4)
b <- binit
V <- V0
z <- z0

######### explanatory variable ##########
## ここが問題

# リンク長
cc <- array(exp(0), dim = c(1, L))

for(a in 1:L){
  cc[1, a] <- exp(link$Length[a] / 100)
}

CC <- array(rep(cc), dim = c(L, L))
CC <- t(CC)

# 店舗数
ss <- array(exp(0), dim = c(1, L))

for(a in 1:L){
  ss[1, a] <- exp(link$N_shops[a] / 50)
}

SS <- array(rep(ss), dim = c(L, L))
SS <- t(SS)

# 駐車場からの距離
Distance <- read.csv(inputDistancePass)
DList <- list()

for(d in 1:D){
  dn <- (1:L)[linkid == ddata[d]]
  tt <- array(exp(0), dim = c(1, L))
  for(a in 1:L){
    tt[1, a] <- exp(Distance[a, dn] / 200)
  }
  TT <- array(rep(tt), dim = c(L, L))
  DList[[d]] <- t(TT)
}


#########################################
######## log-likelihood function ########
#########################################
fr <- function(x) { 

  LL <- 0 
  theta <- exp(x[4]) / (1+exp(x[4]))
  
  for(d in 1:D){
    dn <- (1:L)[linkid == ddata[d]]
    
    dd <- ddata[d]
    Id <- Ilist[[d]]
    
    # 価値関数
    z <- array(exp(theta * V[,d]), dim = c(L, 1))
    ZD <-  array(rep(z), dim = c(L, L))
    ZD <- t(ZD)
    
    # 瞬間効用
    TT <- DList[[d]]
    M <- Id * (CC ^ x[1]) * (SS ^ x[2]) * (TT ^ x[3])
    M[, dn] <- exp(0)
    
    # 選択確率を計算
    Mz <- (M %*% z != 0) * (M %*% z) + (M %*% z == 0)
    MZ <- array(rep(Mz), dim = c(L, L))
    p <- (M * ZD) / MZ
    p <- (p == 0) * 1 + (p != 0) * p
    
    klink <- dataList[[d]]$k
    alink <- dataList[[d]]$a
    hhd <- nrow(dataList[[d]])
    
    # 対数尤度関数を計算
    for(h in 1:hhd){
      pka <- 0
      
      if(alink[h] == dd){
        pka <- 1
      }else{
        k <- (1:L)[linkid == klink[h]]
        a <- (1:L)[linkid == alink[h]]
        if(p[k,a] == 0){
          pka <- 1
        }else{
          pka <- p[k,a]
        }
      }
      
      LL <- LL + log(pka)
    }
  }
  
  print(LL)
  return(LL)
}

#########################################
############ value function #############
#########################################
newV <- function(x) {
  theta <- exp(x[4])/(1+exp(x[4]))
  
  z <- matrix(1, nrow = L, ncol = D) #exp(Vd)
  V <- matrix(0, nrow = L, ncol = D)
  i <- 0
  
  for (d in 1:D){
    kd <- (1:L)[linkid == ddata[d]]
    z[kd, d] <- 1
    
    M <- matrix(0, nrow = L, ncol = L)
    B <- matrix(0, nrow = L, ncol = 1)
    B[kd, 1] <- 1
    
    Id <- Ilist[[d]]
    TT <- DList[[d]]
    
    # 瞬間効用Mを更新
    for (k in 1:L){
      for (a in 1:L){
        Ika <- Id[k, a]
        if(Ika == 1){
          if(a == kd){
            M[k, a] <- 1
          }else{
            M[k, a] <- (CC[k, a] ^ x[1]) * (SS[k, a] ^ x[2]) * (TT[k, a] ^ x[3])
          }
        }
      }
    }
    
    dL <- 100
    zi <- matrix(z[,d], nrow = L, ncol = 1)
    
    # 価値関数zの求解
    while(dL > 0.01){
      zii <- zi
      Xz <- (zii) ^ theta
      zi <- M %*% Xz + B
      dL <- sum(abs(zii - zi))
      i <- i + 1
    }
    z[,d] <- zi
    zi <- (zi == 0) * 1 + (zi != 0) * zi
    V[,d] <- log(zi)
  }
  print(i)
  return(z)
}


#########################################
######### actual program area ###########
######### structural estimtion ##########
#########################################

dL <- 100
n <- 0

while(dL>=0.01){
  n <- n + 1
  
  b0 <- b
  z <- z0
  V <- V0
  
  res <- optim(b0, fr, method = "Nelder-Mead", hessian = TRUE, control=list(fnscale=-1))
  b <- res$par
  cat("b  =")
  print(b)
  cat("lnL=")
  print(res$value)
  #updating value funciton
  z0 <- newV(b)
  
  #convergence condition
  #  dL <- sum(abs(V - V0)) + sum(abs(b - b0))
  zz <- (z == 0) * 1 + (z != 0) * z
  V <- log(zz)
  zz0 <- (z0 == 0) * 1 + (z0 != 0) * z0
  V0 <- log(zz0)
  #cat("V0 =")
  #print(V0)
  dL <- sum(abs(V - V0)) + sum(abs(b - b0))
  cat("dL =")
  print(dL)
}

hhh <- res$hessian
print(n)
tval <- b / sqrt(-diag(solve(hhh)))
LL <- res$value
binit[4] <- b[4]
Lc <- fr(binit)

##########  estimation result ###########
print(res)
print(Lc) 
print(LL)
print((Lc-LL)/Lc) 
print((Lc-(LL-length(b)))/Lc) 
print(b)
theta <- exp(b[4]) / (1 + exp(b[4]))
print(theta)
print(tval)

########## calculation time #############
message("ALL COMPLETED!\n")
print(proc.time()-t)

